---
title: "1.0.0 - Release Candidate"
linkTitle: "1.0.0-rc"
date: "2019-09-09"
---

This is the 1.0.0-rc release of Agones.

We continues with documentation updates, making some improvements to local development tools and
improving error validation handling.

Next week will be the stable 1.0.0 release 🎉

**We are now in feature freeze until Tuesday, 17th of September. This means only docs, bug fixes and tests PRs will be merged during this time.**  
(Other PRs will be labelled `feature-freeze-do-not-merge` and will be held until after that date)

Check the <a href="https://github.com/googleforgames/agones/tree/release-1.0.0-rc" >README</a> for details on features, installation and usage.

**Implemented enhancements:**

- JSON serialisation error reporting on Mutation/Validation webhooks [\#992](https://github.com/googleforgames/agones/issues/992)
- CRASH for simple-udp example [\#1032](https://github.com/googleforgames/agones/pull/1032) ([markmandel](https://github.com/markmandel))
- Rust SDK: Reserved [\#1030](https://github.com/googleforgames/agones/pull/1030) ([markmandel](https://github.com/markmandel))
- Define the proto definition for the allocator service [\#1025](https://github.com/googleforgames/agones/pull/1025) ([pooneh-m](https://github.com/pooneh-m))
- Documentation on Fleet Updates and Upgrades [\#1020](https://github.com/googleforgames/agones/pull/1020) ([markmandel](https://github.com/markmandel))
- Documentation on how to upgrade Agones and/or Kubernetes. [\#1008](https://github.com/googleforgames/agones/pull/1008) ([markmandel](https://github.com/markmandel))
- Output JSON unmarshal error as Admission response [\#1005](https://github.com/googleforgames/agones/pull/1005) ([aLekSer](https://github.com/aLekSer))
- Add GameServer troubleshooting guide [\#1003](https://github.com/googleforgames/agones/pull/1003) ([markmandel](https://github.com/markmandel))
- Local SDK Server: Add proper GS state handling [\#979](https://github.com/googleforgames/agones/pull/979) ([aLekSer](https://github.com/aLekSer))
- Add allocations metrics [\#963](https://github.com/googleforgames/agones/pull/963) ([cyriltovena](https://github.com/cyriltovena))

Documentation: https://development.agones.dev/site/

See <a href="https://github.com/googleforgames/agones/blob/release-1.0.0-rc/CHANGELOG.md" >CHANGELOG</a> for more details on changes.

This software is currently alpha, and subject to change. Not to be used in production systems.

Images available with this release:

- [gcr.io/agones-images/agones-controller:1.0.0-rc](https://gcr.io/agones-images/agones-controller:1.0.0-rc)
- [gcr.io/agones-images/agones-sdk:1.0.0-rc](https://gcr.io/agones-images/agones-sdk:1.0.0-rc)
- [gcr.io/agones-images/agones-ping:1.0.0-rc](https://gcr.io/agones-images/agones-ping:1.0.0-rc)
- [gcr.io/agones-images/cpp-simple-server:0.10](https://gcr.io/agones-images/cpp-simple-server:0.10)
- [gcr.io/agones-images/nodejs-simple-server:0.1](https://gcr.io/agones-images/nodejs-simple-server:0.1)
- [gcr.io/agones-images/rust-simple-server:0.4](https://gcr.io/agones-images/rust-simple-server:0.4)
- [gcr.io/agones-images/unity-simple-server:0.2](https://gcr.io/agones-images/unity-simple-server:0.2)
- [gcr.io/agones-images/udp-server:0.14](https://gcr.io/agones-images/udp-server:0.14)
- [gcr.io/agones-images/xonotic-example:0.6](https://gcr.io/agones-images/xonotic-example:0.6)

Helm chart available with this release:

- <a href="https://agones.dev/chart/stable/agones-1.0.0-rc.tgz" ><code>helm install agones/agones --version 1.0.0-rc</code></a>

> Make sure to add our stable helm repository using `helm repo add https://agones.dev/chart/stable`