---
title: "1.0.0 - A Huge Milestone!"
linkTitle: "1.0.0"
date: "2019-09-16"
---

This is the 1.0.0 release of Agones 🎉
 
Agones is now ready for production workloads. Unless otherwise indicated (by an alpha version), this API surface is now
stable, and all endeavours will be made to maintain its backward compatibility.

Congratulations to everyone involved for code, bug reports, feedback, usage and more. 

Check the <a href="https://github.com/googleforgames/agones/tree/release-1.0.0" >README</a> for details on features, installation and usage.

**Implemented enhancements:**

- JSON serialisation error reporting on Mutation/Validation webhooks [\#992](https://github.com/googleforgames/agones/issues/992)
- CRASH for simple-udp example [\#1032](https://github.com/googleforgames/agones/pull/1032) ([markmandel](https://github.com/markmandel))
- Rust SDK: Reserved [\#1030](https://github.com/googleforgames/agones/pull/1030) ([markmandel](https://github.com/markmandel))
- Define the proto definition for the allocator service [\#1025](https://github.com/googleforgames/agones/pull/1025) ([pooneh-m](https://github.com/pooneh-m))
- Documentation on Fleet Updates and Upgrades [\#1020](https://github.com/googleforgames/agones/pull/1020) ([markmandel](https://github.com/markmandel))
- Documentation on how to upgrade Agones and/or Kubernetes. [\#1008](https://github.com/googleforgames/agones/pull/1008) ([markmandel](https://github.com/markmandel))
- Output JSON unmarshal error as Admission response [\#1005](https://github.com/googleforgames/agones/pull/1005) ([aLekSer](https://github.com/aLekSer))
- Add GameServer troubleshooting guide [\#1003](https://github.com/googleforgames/agones/pull/1003) ([markmandel](https://github.com/markmandel))
- Local SDK Server: Add proper GS state handling [\#979](https://github.com/googleforgames/agones/pull/979) ([aLekSer](https://github.com/aLekSer))
- Add allocations metrics [\#963](https://github.com/googleforgames/agones/pull/963) ([cyriltovena](https://github.com/cyriltovena))

See <a href="https://github.com/googleforgames/agones/blob/release-1.0.0/CHANGELOG.md" >CHANGELOG</a> for more details on changes.

Images available with this release:

- [gcr.io/agones-images/agones-controller:1.0.0](https://gcr.io/agones-images/agones-controller:1.0.0)
- [gcr.io/agones-images/agones-sdk:1.0.0](https://gcr.io/agones-images/agones-sdk:1.0.0)
- [gcr.io/agones-images/agones-ping:1.0.0](https://gcr.io/agones-images/agones-ping:1.0.0)
- [gcr.io/agones-images/cpp-simple-server:0.10](https://gcr.io/agones-images/cpp-simple-server:0.10)
- [gcr.io/agones-images/nodejs-simple-server:0.1](https://gcr.io/agones-images/nodejs-simple-server:0.1)
- [gcr.io/agones-images/rust-simple-server:0.5](https://gcr.io/agones-images/rust-simple-server:0.5)
- [gcr.io/agones-images/unity-simple-server:0.2](https://gcr.io/agones-images/unity-simple-server:0.2)
- [gcr.io/agones-images/udp-server:0.15](https://gcr.io/agones-images/udp-server:0.15)
- [gcr.io/agones-images/xonotic-example:0.6](https://gcr.io/agones-images/xonotic-example:0.6)

Helm chart available with this release:

- <a href="https://agones.dev/chart/stable/agones-1.0.0.tgz" ><code>helm install agones/agones --version 1.0.0</code></a>

> Make sure to add our stable helm repository using `helm repo add agones https://agones.dev/chart/stable`
