---
title: "1.12.0 - Release Candidate"
linkTitle: "1.12.0-rc"
date: "2021-01-26"
---

This is the 1.12.0-rc release of Agones.

A few things to note in this release:
- The `GameServer` CRD now includes the full `PodTemplateSpec` json schema, to provide better up-front validation.
  This should be entirely backward compatible, but in case you run into issues, the helm configuration option
  `gameservers.podPreserveUnknownFields` is available to disable validation and field pruning.
  - If you are using Helm, you might need to update your Helm version and/or do a clean install to apply this update to
    your cluster if you already have a version of Agones installed, due to the size of the CRD update.
- `SDKWatchSendOnExecute` has been moved to Beta, so by default you will get a copy of the most recent `GameServer`
  information with your initial `SDK.WatchGameServer(...)` request.
- The ability to apply port allocation to multiple containers has moved from Beta to Stable!

Check the <a href="https://github.com/googleforgames/agones/tree/release-1.12.0-rc" data-proofer-ignore>README</a> for details on features, installation and usage.

**Breaking changes:**

- Move SDKWatchSendOnExecute to Beta [\#1904](https://github.com/googleforgames/agones/issues/1904)
- Move `SDKWatchSendOnExecute` to Beta stage. [\#1960](https://github.com/googleforgames/agones/pull/1960) ([markmandel](https://github.com/markmandel))
- Utilize ExternalDNS as well as ExternalIP [\#1928](https://github.com/googleforgames/agones/pull/1928) ([nanasi880](https://github.com/nanasi880))

**Implemented enhancements:**

- Utilize ExternalDNS as well as ExternalIP [\#1921](https://github.com/googleforgames/agones/issues/1921)
- Move "Port Allocations to Multiple Containers" \> Stable [\#1773](https://github.com/googleforgames/agones/issues/1773)
- Move ContainerPortAllocation to Stable [\#1961](https://github.com/googleforgames/agones/pull/1961) ([markmandel](https://github.com/markmandel))
- CRD OpenAPI Spec for ObjectMeta & PodTemplateSpec [\#1956](https://github.com/googleforgames/agones/pull/1956) ([markmandel](https://github.com/markmandel))
- Add a "why" section for the Allocator Service documentation [\#1953](https://github.com/googleforgames/agones/pull/1953) ([markmandel](https://github.com/markmandel))
- Add nodeSelector property to Agones helm chart for Allocator [\#1946](https://github.com/googleforgames/agones/pull/1946) ([josephbmanley](https://github.com/josephbmanley))

Documentation: https://development.agones.dev/site/

See <a href="https://github.com/googleforgames/agones/blob/release-1.12.0-rc/CHANGELOG.md" data-proofer-ignore>CHANGELOG</a> for more details on changes.

Images available with this release:

- [gcr.io/agones-images/agones-controller:1.12.0-rc](https://gcr.io/agones-images/agones-controller:1.12.0-rc)
- [gcr.io/agones-images/agones-sdk:1.12.0-rc](https://gcr.io/agones-images/agones-sdk:1.12.0-rc)
- [gcr.io/agones-images/agones-ping:1.12.0-rc](https://gcr.io/agones-images/agones-ping:1.12.0-rc)
- [gcr.io/agones-images/agones-allocator:1.12.0-rc](https://gcr.io/agones-images/agones-allocator:1.12.0-rc)
- [gcr.io/agones-images/autoscaler-webhook:0.3](https://gcr.io/agones-images/autoscaler-webhook:0.3)
- [gcr.io/agones-images/cpp-simple-server:0.13](https://gcr.io/agones-images/cpp-simple-server:0.13)
- [gcr.io/agones-images/crd-client:0.3](https://gcr.io/agones-images/crd-client:0.3)
- [gcr.io/agones-images/nodejs-simple-server:0.5](https://gcr.io/agones-images/nodejs-simple-server:0.5)
- [gcr.io/agones-images/rust-simple-server:0.8](https://gcr.io/agones-images/rust-simple-server:0.8)
- [gcr.io/agones-images/simple-game-server:0.1](https://gcr.io/agones-images/simple-game-server:0.1)
- [gcr.io/agones-images/tcp-server:0.4](https://gcr.io/agones-images/tcp-server:0.4)
- [gcr.io/agones-images/udp-server:0.21](https://gcr.io/agones-images/udp-server:0.21)
- [gcr.io/agones-images/supertuxkart-example:0.3](https://gcr.io/agones-images/supertuxkart-example:0.3)
- [gcr.io/agones-images/unity-simple-server:0.3](https://gcr.io/agones-images/unity-simple-server:0.3)
- [gcr.io/agones-images/xonotic-example:0.8](https://gcr.io/agones-images/xonotic-example:0.8)

Helm chart available with this release:

- <a href="https://agones.dev/chart/stable/agones-1.12.0-rc.tgz" data-proofer-ignore>
  <code>helm install agones agones/agones --version 1.12.0-rc</code></a>

> Make sure to add our stable helm repository using `helm repo add agones https://agones.dev/chart/stable`